package com.hzs.system.sys.mapper;

import java.util.List;

import com.hzs.common.domain.system.sys.SysDept;
import com.hzs.system.sys.param.SysDeptQueryParam;
import com.hzs.system.sys.vo.SysDeptQueryVO;
import org.apache.ibatis.annotations.Param;

/**
 * 部门管理 数据层
 *
 * @author hzs
 */
public interface SysDeptMapper {

    /**
     * 查询部门管理数据
     *
     * @param param
     * @return
     */
    List<SysDeptQueryVO> selectDeptList(@Param("param") SysDeptQueryParam param);

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    SysDept selectDeptById(Long deptId);

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果
     */
    int checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     *
     * @param deptName 部门名称
     * @return 结果
     */
    SysDept checkDeptNameUnique(@Param("deptName") String deptName);

    /**
     * 新增部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    int insertDept(SysDept dept);

    /**
     * 修改部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    int updateDept(SysDept dept);

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @param userId
     * @return
     */
    int deleteDeptById(@Param("deptId") Long deptId, @Param("userId") Long userId);

    /**
     * getMaxDeptCode
     *
     * @return
     */
    String getMaxDeptCode();

    /**
     * 查询重复部门
     *
     * @param userIdList
     * @return
     */
    List<Long> queryRepeatDept(@Param("userIdList") List<Long> userIdList);

}
